precision highp float;

uniform sampler2D textureUnit0;
uniform sampler2D textureUnit1;
uniform sampler2D textureUnit2;
uniform sampler2D textureUnit3;

varying vec2 texCoord0;
varying vec2 texCoord1;
varying vec2 texCoord2;
varying vec2 texCoord3;

varying vec4 vertexColor;
varying vec4 fogVertexColor;

void main (void)
{
	vec4 col0 = texture2D(textureUnit0, texCoord0);
	vec4 col1 = texture2D(textureUnit1, texCoord1);
	vec4 col2 = texture2D(textureUnit2, texCoord2);
	vec4 col3 = col2*0.4;
	vec4 blend = texture2D(textureUnit3, texCoord3);
	
	//gl_FragColor = fogWeight * (vertexColor*(vec4(col0.rgb*(1.0-w1)*(1.0-w2)*(1.0-w3),0.0)+vec4(col1.rgb*w1,0.0)+vec4(col2.rgb*w2,0.0)+vec4(col3.rgb*w3,0.0))) + fogVertexColor;
	//gl_FragColor = vertexColor * vec4(((1.0-w1)*(1.0-w2)*(1.0-w3)*col0+col1*w1+col2*w2+col3*w3).rgb, 0.0) + fogVertexColor;
	
	//col0 = mix(mix(mix(col0, col1, w1), col2, w2), col3, w3);
	//col0.a=0.0;
	gl_FragColor = vertexColor *  mix(mix(mix(col0, col1, blend.r), col2, blend.g), col3, blend.b) + fogVertexColor;
}