precision highp float;

varying vec3 eyeVec;
varying vec2 texCoord;
varying vec4 vertexColor;
varying vec4 diffuseColor;
varying vec3 lVec;
varying float fogWeight;
varying float att;

uniform sampler2D textureUnit0;
uniform sampler2D textureUnit1;

uniform vec4 ambientColor;
uniform float heightScale;

void main ()
{
	float height = texture2D(textureUnit1, texCoord).a;
	vec2 newTexCoord = texCoord + (eyeVec.xy * ((height * 2.0 - 1.0) * heightScale));
	
	vec4 base = texture2D(textureUnit0, newTexCoord) * fogWeight;
	vec3 bump = normalize(texture2D(textureUnit1, newTexCoord).xyz * 2.0 - 1.0);
		
	vec4 vDiffuse = ambientColor + diffuseColor * max(dot(lVec, bump), 0.0);	
	
	gl_FragColor = base*(vDiffuse*att + vertexColor);
}