attribute vec2 texture0;
attribute vec4 position;
attribute vec3 normal;

uniform vec4 additionalColor; 
uniform vec4 ambientColor;

uniform mat4 modelViewMatrix;
uniform mat4 modelViewProjectionMatrix; 

uniform float fogStart;
uniform float fogEnd;
uniform vec3 fogColor;

uniform float alpha;
uniform float random;

varying vec2 texCoord0;
varying vec4 vertexColor;
varying vec4 fogVertexColor;

const vec4 WHITE = vec4(1.0,1.0,1.0,1.0);

void main(void)
{
	texCoord0=texture0;
	vec3 vVertex = vec3(modelViewMatrix * position);
		
	vertexColor=vec4(min(WHITE, additionalColor+ambientColor*2.0).xyz, alpha);
	
	float fogWeight = clamp((-vVertex.z - fogStart) / (fogEnd - fogStart), 0.0, 1.0);
	fogVertexColor = vec4(fogColor,0.0) * fogWeight;
	fogWeight = (1.0-fogWeight);
	
	vec4 pos= modelViewProjectionMatrix * position;
	
	if (texCoord0.y<0.5) {
		float cosy=cos(mod(random*0.005+(position.z+position.x)*0.25, 6.2831));
		pos.x=pos.x+cosy;
		pos.y=pos.y-cosy;
	}
	
	vertexColor*=fogWeight;
	
	gl_Position = pos;
}