precision highp float;

uniform sampler2D textureUnit0;
uniform sampler2D textureUnit1;

varying vec2 texCoord0;

varying vec4 vertexColor;
varying vec4 fogVertexColor;

uniform vec3 colorMul0;
uniform vec3 colorMul1;
uniform vec3 colorMul2;

void main (void)
{
	vec4 col0 = texture2D(textureUnit0, texCoord0);
	vec4 blend = texture2D(textureUnit1, texCoord0);
	
	float w1=blend.r;
	float w2=blend.g;
	float w3=blend.b;
	
	gl_FragColor = vertexColor *  mix(mix(mix(col0, col0*vec4(colorMul0, 1.0), w1), col0*vec4(colorMul1, 1.0), w2), col0*vec4(colorMul2, 1.0), w3) + fogVertexColor;
}