attribute vec2 texture0;
attribute vec4 position;
attribute vec3 normal;

uniform vec4 additionalColor; 
uniform vec4 ambientColor;

uniform mat4 modelViewMatrix;
uniform mat4 modelViewProjectionMatrix; 

uniform float fogStart;
uniform float fogEnd;
uniform vec3 fogColor;

uniform float alpha;
uniform float random;
uniform float textureClip;

varying vec2 texCoord0;
varying vec4 vertexColor;
varying vec4 fogVertexColor;

const vec4 WHITE = vec4(1.0,1.0,1.0,1.0);

void main(void)
{
	texCoord0=texture0;
	
	vertexColor = additionalColor+vec4(0.35,0.35,0.35,alpha);
	vec3 vVertex = vec3(modelViewMatrix * position);
		
	vertexColor=vec4(min(WHITE, vertexColor).xyz, alpha);
	
	float fogWeight = clamp((-vVertex.z - fogStart) / (fogEnd - fogStart), 0.0, 1.0);
	fogVertexColor = vec4(fogColor,0.0) * fogWeight;
	fogWeight = (1.0-fogWeight);
	
	vertexColor*=fogWeight;
	vertexColor*=2.0;
	
	gl_Position = modelViewProjectionMatrix * position;
}