precision mediump float;

varying vec3 normalVec, lightDir, eyeVec;
varying vec2 texCoord;

uniform sampler2D textureUnit0;

uniform vec4 additionalColor; 
uniform vec4 ambientColor;

varying vec4 diffuseColor;
varying vec4 vertexColor;
		
void main(void)
{
	vec4 base = texture2D(textureUnit0, texCoord);
	vec4 finalColor = additionalColor + ambientColor;

	float dist=length(lightDir);
	vec3 L = normalize(lightDir);
	vec3 N = normalize(normalVec);

	float lambertTerm = dot(N,L);
	if(lambertTerm > 0.0)
	{
		finalColor += diffuseColor * lambertTerm;	
	} 
	
	gl_FragColor = (vec4((finalColor*(min(2.0, 70.0/dist))).rgb, 0.0)+vertexColor)*2.0*base;
}