precision mediump float;

varying vec3 normalVec, lightDir, eyeVec;
varying vec2 texCoord;

uniform sampler2D textureUnit0;
uniform sampler2D textureUnit1;

uniform vec4 additionalColor; 
uniform vec4 ambientColor;

varying vec4 diffuseColor;
varying vec4 vertexColor;

uniform vec3 colorMul0;
uniform vec3 colorMul1;
uniform vec3 colorMul2;
		
void main(void)
{
	vec4 col0 = texture2D(textureUnit0, texCoord);
	vec4 blend = texture2D(textureUnit1, texCoord);
	
	float w1=blend.r;
	float w2=blend.g;
	float w3=blend.b;
	
	vec4 finalColor = additionalColor + ambientColor;

	float dist=length(lightDir);
	vec3 L = normalize(lightDir);
	vec3 N = normalize(normalVec);

	float lambertTerm = dot(N,L);
	if(lambertTerm > 0.0)
	{
		finalColor += diffuseColor * lambertTerm;	
	} 
	
	gl_FragColor = (vec4((finalColor*(min(2.0, 70.0/dist))).rgb, 0.0)+vertexColor)*2.0*(mix(mix(mix(col0, col0*vec4(colorMul0, 1.0), w1), col0*vec4(colorMul1, 1.0), w2), col0*vec4(colorMul2, 1.0), w3));
}